//
// Ephi - simulation of magnetic fields and particles
// Copyright (C) 2007 Indrek Mandre <indrek(at)mare.ee>
// For more information please see http://www.mare.ee/indrek/ephi/
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef __consts_hpp__
#define __consts_hpp__

// from http://physics.nist.gov/cuu/Constants/index.html
#define ELEMENTARY_CHARGE 1.602176487e-19 //< coulomb
#define ELECTRON_MASS 9.10938215e-31 //< kg
#define MAGNETIC_CONSTANT 0.1e-6
#define SPEED_OF_LIGHT 299792458.0 //< m/s

#endif // !__consts_hpp__

