
#ifndef __ephi_hpp__
#define __ephi_hpp__

#include <math.h>
#include <float.h>
#include <stdarg.h>
#include <limits.h>

class Ephi
{
public:
  static void debug (int level, const char *fmt, ...);
  static void debug (int level, const char *fmt, va_list ap);
  static void setDebugLevel (int level) { debug_level = level; }

  enum { DEBUG_CRITICAL = 1, DEBUG_ERROR = 2, DEBUG_WARN, DEBUG_INFO = 10 };

private:
  static int debug_level;
};

#if LONG_MAX == 2147483647L
  #define LONG_IS_32BIT
#endif

#include "math3d.hpp"
#include "matrix.hpp"
#include "consts.hpp"
#include "utils.hpp"
#include "statics.hpp"
#include "dynamics.hpp"
#include "screen.hpp"
#include "scene.hpp"
#include "config.hpp"
#include "polywell_conf.hpp"
#include "threading.hpp"
#include "coildata.hpp"
#include "potential.hpp"
#include "octree.hpp"

#endif

